//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
USERES("MemoryStatus.res");
USEFORM("MemoryStatusUnit.cpp", Form1);

TMemoryManager mmNew;
TMemoryManager mmOld;

int iGetMemCount, iFreeMemCount, iReallocMemCount;

Pointer __fastcall NewGetMem(int iSize);
int __fastcall NewFreeMem(Pointer p);
Pointer __fastcall NewReallocMem(Pointer p, int iSize);

//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
  try
  {
    mmNew.GetMem = NewGetMem;
    mmNew.FreeMem = NewFreeMem;
    mmNew.ReallocMem = NewReallocMem;

    GetMemoryManager(mmOld);
    SetMemoryManager(mmNew);

    try
    {
       Application->Initialize();
       Application->CreateForm(__classid(TForm1), &Form1);
       Application->Run();
    }
    catch (Exception &exception)
    {
       Application->ShowException(&exception);
    }
  }
  __finally
  {
    SetMemoryManager(mmOld);
  }

  return 0;
}
//---------------------------------------------------------------------------
Pointer __fastcall NewGetMem(int iSize)
{
  iGetMemCount++;
  return mmOld.GetMem(iSize);
}

int __fastcall NewFreeMem(Pointer p)
{
  iFreeMemCount++;
  return mmOld.FreeMem(p);
}

Pointer __fastcall NewReallocMem(Pointer p, int iSize)
{
  iReallocMemCount++;
  return mmOld.ReallocMem(p, iSize);
}

